<?php

namespace Drupal\social_auth\ParamConverter;

use Drupal\social_api\Plugin\NetworkManager;
use Symfony\Component\Routing\Route;
use Drupal\Core\ParamConverter\ParamConverterInterface;

/**
 * Provides upcasting for a network instance.
 *
 * @package Drupal\social_auth\ParamConverter
 */
class NetworkConverter implements ParamConverterInterface {

  /**
   * Network manager.
   *
   * @var \Drupal\social_api\Plugin\NetworkManager
   */
  protected NetworkManager $networkManager;

  /**
   * Constructs a NetworkConverter instance.
   *
   * @param \Drupal\social_api\Plugin\NetworkManager $network_manager
   *   Network manager.
   */
  public function __construct(NetworkManager $network_manager) {
    $this->networkManager = $network_manager;
  }

  /**
   * {@inheritdoc}
   */
  public function convert($value, $definition, $name, array $defaults): object {
    return $this->networkManager->createInstance("social_auth_$value");
  }

  /**
   * {@inheritdoc}
   */
  public function applies($definition, $name, Route $route): bool {
    return !empty($definition['type']) && $definition['type'] === 'network';
  }

}
